<template>
  <div class="WireframesTab _tabcontent">
    <tab-simple
      v-model="items"
      v-show="!wireframeSrc && !newWireframeSrc"
      :is-tab-active="isTabActive"
      :item-title="'L: open in frame, R: copy path to clipboard'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="wireframes"
      single-item="wireframe">
      <template slot="controls" slot-scope="prop">
        <i @click="openInBrowser(prop.item)" class="fa fa-chrome" aria-hidden="true" title="open in browser"></i>
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" aria-hidden="true" title="rename wireframe"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" aria-hidden="true" title="delete wireframe"></i>
      </template>
    </tab-simple>
    <el-button
      v-if="wireframeSrc || newWireframeSrc"
      @click="wireframeSrc = '';newWireframeSrc = '';"
      type="primary"
      class="_cancelButton">
      cancel
    </el-button>
    <iframe
      v-if="wireframeSrc && !newWireframeSrc"
      class="_wireframe"
      :src="wireframeSrc"
      nwdisable
      nwfaketop
      nwuseragent="Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36">
    </iframe>
    <iframe
      v-if="newWireframeSrc"
      ref="newWireframe"
      class="_newWireframe"
      :src="newWireframeSrc"
      nwdisable
      nwfaketop
      nwuseragent="Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36">
    </iframe>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
      wireframeSrc: '',
      newWireframeSrc: '',
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data } = await this.$axios.get(`/wireframes/get`)
        this.items = data
      }
    },
    leftClick(item) {
      const wireframePath = path.join(sourcesDir, 'wireframes', `${item.name}.json`)
      this.wireframeSrc = ''
      this.newWireframeSrc = ''
      jsonfile.readFile(wireframePath, (err, wireframe) => {
        this.wireframeSrc = wireframe.url
      })
    },
    rightClick(item) {
      const wireframePath = path.join(sourcesDir, 'wireframes', `${item.name}.json`)
      jsonfile.readFile(wireframePath, (err, wireframe) => {
        const clipboard = nw.Clipboard.get()
        clipboard.set(wireframe.url, 'text')
        this.$axios.post('/notify', {
          text: wireframe.url,
          title: 'copied to clipboard',
          icon: 'success.png',
        })
      })
    },
    middleClick(item) {

    },
    openInBrowser(item) {
      const wireframePath = path.join(sourcesDir, 'wireframes', `${item.name}.json`)
      jsonfile.readFile(wireframePath, (err, wireframe) => {
        open(wireframe.url)
      })
    },
    createItem() {
      this.wireframeSrc = ''
      this.newWireframeSrc = 'https://wireframe.cc'
      this.$nextTick(() => {
        const $newWireframe = $(this.$refs.newWireframe)
        const onClickSave = () => {
          this.$prompt(`Create wireframe`, '', {
            confirmButtonText: 'OK',
            cancelButtonText: 'Cancel',
            inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
            inputErrorMessage: 'Invalid wireframe name'
          }).then((data) => {
            const wireframeName = data.value
            const newWireFrameUrl = $newWireframe[0].contentWindow.location.href
            const wireframeSavePath = path.join(sourcesDir, 'wireframes', `${wireframeName}.json`)
            jsonfile.writeFile(wireframeSavePath, { url:  newWireFrameUrl }, { spaces: 2 }, async (err) => {
              if (!err) {
                this.$message({
                  message: 'Wireframe created',
                  type: 'success'
                })
                const { data: wireframes } = await this.$axios.get(`/wireframes/get`)
                this.items = wireframes
                this.newWireframeSrc = ''
                this.wireframeSrc = newWireFrameUrl
              } else {
                this.$message.error(err)
              }
            })
          }).catch(e => {
            this.newWireframeSrc = ''
            this.wireframeSrc = ''
            console.log(e)
          })
        }
        $newWireframe.on('load', () => {
          $newWireframe.contents().find('body').on('click', '#savefree', onClickSave)
        })
      })
    },
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" wireframe to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid wireframe name'
      }).then(async (data) => {
        const newWireframeName = data.value
        if (newWireframeName && newWireframeName !== item.name) {
          await this.$axios.post(`/wireframes/rename/${item.name}`, {
            newName: data.value
          })
          const index = _.findIndex(this.items, { name: item.name });
          this.items.splice(index, 1, { name: newWireframeName })
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete wireframe ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post(`/wireframes/delete/${item.name}`)
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./WireframesTab.less";
</style>